<template>
  <div class="sidebar">
    <el-dialog
      v-model="visible"
      destroy-on-close
      width="100%"
      custom-class="sidebar-dialog"
      :show-close="false"
    >
      <template #title>
        <div class="h-fit">
          <div class="relative">
            <div class="flex justify-start h-[80px] items-center">
              <h2
                class="text-center text-[24px] text-[var(--title-font-color)] uppercase leading-1 font-bold mr-10 ml-[2.5rem]"
              >
                {{ $t("game_types") }}
              </h2>
            </div>
            <div
              class="absolute top-[12px] right-[15px] bg-[var(--button-bg)] box-shadow text-[var(--title-font-color)] rounded-[6px] h-10 w-10 flex items-center justify-center"
            >
              <font-awesome-icon
                class="text-[27px]"
                icon="xmark"
                @click="close"
              />
            </div>
          </div>
        </div>
      </template>
      <div class="mt-[1rem] pb-3 px-10">
        <ul class="grid grid-cols-1 gap-[20px] my-0 pl-0">
          <li
            v-for="gameType in gameTypes"
            :key="gameType"
            class="w-auto text-center overflow-hidden leading-[1.5] py-[10px] px-2 bg-[var(--button-bg)] box-shadow rounded-lg"
          >
            <div @click="handleProviderClicked(gameType)">
              <div
                class="mb-[10px] h-20 p-[5px] border-[var(--border-color)] border-b-[1px] flex justify-center"
              >
                <img
                  class="object-scale-down max-h-full max-w-full"
                  :src="
                    getAssetImage(
                      `assets/theme/black_modern_1/images/gameIcons/${gameType
                        .split(' ')
                        .join('')}.png`
                    )
                  "
                  alt=""
                />
              </div>
              <p
                class="flex justify-between items-center text-[var(--title-font-color)] mb-0"
              >
                <span
                  class="text-sm overflow-hidden overflow-ellipsis whitespace-nowrap max-w-[90%]"
                >
                  {{ $t(gameType) }}
                </span>
                <font-awesome-icon
                  class="text-2xl leading-[14px]"
                  icon="arrow-right"
                />
              </p>
            </div>
          </li>
        </ul>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";

export default defineComponent({
  props: {
    gameTypeDialogVisible: {
      type: Boolean,
      required: true,
    },
    handleClick: {
      type: Function,
      required: false,
      default: () => {},
    },
  },
  emits: ["update:gameTypeDialogVisible"],
  setup(props, { emit }) {
    const { gameTypeDialogVisible: visible } = toRefs(props);
    const { getAssetImage } = commonHelper;
    const router = useRouter();
    const close = () => {
      emit("update:gameTypeDialogVisible", false);
    };
    const handleProviderClicked = (path: string) => {
      emit("update:gameTypeDialogVisible", false);
      router.push(`/games/${path}__n__gt`);
      props.handleClick?.();
    };
    const gameTypes = computed(
      () => store.state.gameTabProviderList.SeamlessGameGameTypeList
    );
    return {
      handleProviderClicked,
      getAssetImage,
      close,
      visible,
      gameTypes,
    };
  },
});
</script>
